Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 4901)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 1)
@@ -773,421 +349,346 @@
        CASE ( 'euler' )
           intermediate_timestep_count_max = 1
+          asselin_filter_factor           = 0.0
+
+       CASE ( 'leapfrog', 'leapfrog+euler' )
+          intermediate_timestep_count_max = 1
 
        CASE ( 'runge-kutta-2' )
           intermediate_timestep_count_max = 2
+          asselin_filter_factor           = 0.0
 
        CASE ( 'runge-kutta-3' )
           intermediate_timestep_count_max = 3
+          asselin_filter_factor           = 0.0
 
        CASE DEFAULT
-          message_string = 'unknown timestep scheme: timestep_scheme = "' //                       &
-                           TRIM( timestep_scheme ) // '"'
-          CALL message( 'check_parameters', 'PA0027', 1, 2, 0, 6, 0 )
+          IF ( myid == 0 )  PRINT*, '+++ check_parameters:  unknown timestep ',&
+                                    'scheme: timestep_scheme=', timestep_scheme
+          CALL local_stop
 
     END SELECT
 
-    IF ( ( momentum_advec /= 'pw-scheme' .AND. momentum_advec /= 'ws-scheme' )                     &
-         .AND.  timestep_scheme(1:5) == 'runge' ) THEN
-       message_string = 'momentum advection scheme "' // TRIM( momentum_advec ) //                 &
-                        '" & does not work with timestep_scheme "' // TRIM( timestep_scheme )      &
-                        // '"'
-       CALL message( 'check_parameters', 'PA0029', 1, 2, 0, 6, 0 )
-    ENDIF
-!
-!-- Check for proper settings for microphysics
-    IF ( bulk_cloud_model  .AND.  cloud_droplets )  THEN
-       message_string = 'bulk_cloud_model = .TRUE. is not allowed with cloud_droplets = .TRUE.'
-       CALL message( 'check_parameters', 'PA0442', 1, 2, 0, 6, 0 )
-    ENDIF
-
-!
-!-- Initializing actions must have been set by the user
-    IF ( TRIM( initializing_actions ) == '' )  THEN
-       message_string = 'no value specified for initializing_actions'
-       CALL message( 'check_parameters', 'PA0149', 1, 2, 0, 6, 0 )
-    ENDIF
-
-    IF ( TRIM( initializing_actions ) /= 'read_restart_data'  .AND.                                &
-         TRIM( initializing_actions ) /= 'cyclic_fill' )  THEN
-!
-!--    No restart run: several initialising actions are possible
+    IF ( scalar_advec /= 'pw-scheme'  .AND.  timestep_scheme(1:5) == 'runge' ) &
+    THEN
+       IF ( myid == 0 )  THEN
+          PRINT*, '+++ check_parameters:  scalar advection scheme "', &
+                                          TRIM( scalar_advec ), '"'
+          PRINT*, '    does not work with timestep_scheme "', &
+                                          TRIM( timestep_scheme ), '"'
+       ENDIF
+       CALL local_stop
+    ENDIF
+
+    IF ( momentum_advec /= 'pw-scheme' .AND. timestep_scheme(1:5) == 'runge' ) &
+    THEN
+       IF ( myid == 0 )  THEN
+          PRINT*, '+++ check_parameters:  momentum advection scheme "', &
+                                          TRIM( momentum_advec ), '"'
+          PRINT*, '    does not work with timestep_scheme "', &
+                                          TRIM( timestep_scheme ), '"'
+       ENDIF
+       CALL local_stop
+    ENDIF
+
+
+    IF ( initializing_actions == ' ' )  THEN
+       IF ( myid == 0 )  THEN
+          PRINT*, '+++ check parameters:'
+          PRINT*, '    no value found for initializing_actions'
+       ENDIF
+       CALL local_stop
+    ENDIF
+
+    IF ( TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
+!
+!--    No model continuation run; several initialising actions are possible
        action = initializing_actions
-       DO  WHILE ( TRIM( action ) /= '' )
+       DO WHILE ( TRIM( action ) /= '' )
           position = INDEX( action, ' ' )
           SELECT CASE ( action(1:position-1) )
 
-             CASE ( 'set_constant_profiles', 'set_1d-model_profiles', 'by_user',                   &
-                    'initialize_vortex', 'initialize_ptanom', 'initialize_bubble', 'inifor' )
+             CASE ( 'set_constant_profiles', 'set_1d-model_profiles', &
+                    'initialize_vortex',     'initialize_ptanom' )
                 action = action(position+1:)
 
              CASE DEFAULT
-                message_string = 'initializing_action = "' //                                      &
-                                 TRIM( action ) // '" unknown or not allowed'
-                CALL message( 'check_parameters', 'PA0030', 1, 2, 0, 6, 0 )
+                IF ( myid == 0 )  PRINT*, '+++ check_parameters: initializi', &
+                               'ng_action unkown or not allowed: action = "', &
+                               TRIM(action), '"'
+                CALL local_stop
 
           END SELECT
        ENDDO
     ENDIF
-
-    IF ( TRIM( initializing_actions ) == 'initialize_vortex'  .AND.  conserve_volume_flow ) THEN
-         message_string = 'initializing_actions = "initialize_vortex"' //                          &
-                          ' is not allowed with conserve_volume_flow = .T.'
-       CALL message( 'check_parameters', 'PA0343', 1, 2, 0, 6, 0 )
-    ENDIF
-
-
-    IF ( INDEX( initializing_actions, 'set_constant_profiles' ) /= 0  .AND.                        &
+    IF ( INDEX( initializing_actions, 'set_constant_profiles' ) /= 0  .AND. &
          INDEX( initializing_actions, 'set_1d-model_profiles' ) /= 0 )  THEN
-       message_string = 'initializing_actions = "set_constant_profiles"' //                        &
-                        ' and "set_1d-model_profiles" are not allowed simultaneously'
-       CALL message( 'check_parameters', 'PA0031', 1, 2, 0, 6, 0 )
-    ENDIF
-
-    IF ( INDEX( initializing_actions, 'set_constant_profiles' ) /= 0  .AND.                        &
-         INDEX( initializing_actions, 'by_user' ) /= 0 )  THEN
-       message_string = 'initializing_actions = "set_constant_profiles"' //                        &
-                        ' and "by_user" are not allowed simultaneously'
-       CALL message( 'check_parameters', 'PA0032', 1, 2, 0, 6, 0 )
-    ENDIF
-
-    IF ( INDEX( initializing_actions, 'by_user' ) /= 0  .AND.                                      &
-         INDEX( initializing_actions, 'set_1d-model_profiles' ) /= 0 )  THEN
-       message_string = 'initializing_actions = "by_user" and ' //                                 &
-                        '"set_1d-model_profiles" are not allowed simultaneously'
-       CALL message( 'check_parameters', 'PA0033', 1, 2, 0, 6, 0 )
-    ENDIF
-!
-!-- In case of spinup and nested run, spinup end time must be identical in order to have
-!-- synchronously running simulations.
-    IF ( nested_run )  THEN
-#if defined( __parallel )
-       CALL MPI_ALLREDUCE( spinup_time, spinup_time_max, 1, MPI_REAL, MPI_MAX, MPI_COMM_WORLD,     &
-                           ierr )
-       CALL MPI_ALLREDUCE( dt_spinup,   dt_spinup_max,   1, MPI_REAL, MPI_MAX, MPI_COMM_WORLD,     &
-                           ierr )
-
-       IF ( spinup_time /= spinup_time_max  .OR.  dt_spinup /= dt_spinup_max )  THEN
-          message_string = 'In case of nesting, spinup_time and ' //                               &
-                           'dt_spinup must be identical in all parent and child domains.'
-          CALL message( 'check_parameters', 'PA0489', 3, 2, 0, 6, 0 )
-       ENDIF
-#endif
-    ENDIF
-
-    IF ( bulk_cloud_model  .AND.  .NOT. humidity )  THEN
-       WRITE( message_string, * ) 'bulk_cloud_model = ', bulk_cloud_model,                         &
-              ' is not allowed with humidity = ', humidity
-       CALL message( 'check_parameters', 'PA0034', 1, 2, 0, 6, 0 )
-    ENDIF
-
-    IF ( humidity  .AND.  sloping_surface )  THEN
-       message_string = 'humidity = .TRUE. and sloping_surface = .TRUE. ' //                       &
-                        'are not allowed simultaneously'
-       CALL message( 'check_parameters', 'PA0036', 1, 2, 0, 6, 0 )
-    ENDIF
-
-!-- Check the module settings
-    CALL module_interface_check_parameters
-
-!
-!-- In case of no restart run, check initialising parameters and calculate further quantities
+       IF ( myid == 0 )  PRINT*, '+++ check_parameters: initializing_actions', &
+          '"set_constant_profiles" and "set_1d-model_profiles" are not', &
+          ' allowed simultaneously'
+       CALL local_stop
+    ENDIF
+
+    IF ( cloud_physics  .AND.  .NOT. moisture )  THEN
+       IF ( myid == 0 )  PRINT*, '+++ check_parameters: moisture =', &
+                                 moisture, ' is not allowed with ',  &
+                                 'cloud_physics=', cloud_physics
+       CALL local_stop
+    ENDIF
+
+    IF ( moisture  .AND.  sloping_surface )  THEN
+       IF ( myid == 0 )  PRINT*, '+++ check_parameters: moisture = TRUE', &
+                                 'and hang = TRUE are not',               &
+                                 ' allowed simultaneously' 
+       CALL local_stop       
+    ENDIF
+
+    IF ( moisture  .AND.  scalar_advec == 'ups-scheme' )  THEN
+       IF ( myid == 0 )  PRINT*, '+++ check_parameters: UPS-scheme', &
+                                 'is not implemented for moisture'
+       CALL local_stop       
+    ENDIF
+
+    IF ( passive_scalar  .AND.  moisture )  THEN
+       IF ( myid == 0 )  PRINT*, '+++ check_parameters: moisture = TRUE and', &
+                                 'passive_scalar = TRUE is not allowed ',     &
+                                 'simultaneously'
+       CALL local_stop
+    ENDIF
+
+    IF ( passive_scalar  .AND.  scalar_advec == 'ups-scheme' )  THEN
+       IF ( myid == 0 )  PRINT*, '+++ check_parameters: UPS-scheme', &
+                                 'is not implemented for passive_scalar'
+       CALL local_stop       
+    ENDIF
+
+    IF ( grid_matching /= 'strict'  .AND.  grid_matching /= 'match' )  THEN
+       IF ( myid == 0 )  PRINT*, '+++ check_parameters: illegal value "', &
+                                 TRIM( grid_matching ),                   &
+                                 '" found for parameter grid_matching'
+       CALL local_stop       
+    ENDIF
+
+!
+!-- In case of no model continuation run, check initialising parameters and
+!-- deduce further quantities
     IF ( TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
 
 !
-!--    Initial profiles for 1D and 3D model, respectively (u,v further below)
+!--    Initial profiles for 1D and 3D model, respectively
+       u_init  = ug_surface
+       v_init  = vg_surface
        pt_init = pt_surface
-       IF ( humidity       )  q_init  = q_surface
-       IF ( passive_scalar )  s_init  = s_surface
-
+       IF ( moisture )        q_init = q_surface
+       IF ( passive_scalar )  q_init = s_surface
+
+!
 !--
-!--    If required, compute initial profile of the geostrophic wind (component ug)
+!--    If required, compute initial profile of the geostrophic wind
+!--    (component ug)
        i = 1
-       gradient = 0.0_wp
-
-       IF ( .NOT. ocean_mode )  THEN
-
-          ug_vertical_gradient_level_ind(1) = 0
-          ug(0) = ug_surface
+       gradient = 0.0
+       ug_vertical_gradient_level_ind(1) = 0
+       ug(0) = ug_surface
+       DO  k = 1, nzt+1
+          IF ( ug_vertical_gradient_level(i) < zu(k)  .AND. &
+               ug_vertical_gradient_level(i) >= 0.0 )  THEN
+             gradient = ug_vertical_gradient(i) / 100.0
+             ug_vertical_gradient_level_ind(i) = k - 1
+             i = i + 1
+             IF ( i > 10 )  THEN
+                IF ( myid == 0 )  THEN
+                   PRINT*, '+++ check_parameters: upper bound 10 of array', &
+                           ' "ug_vertical_gradient_level_ind" exceeded'
+                ENDIF
+                CALL local_stop
+             ENDIF
+          ENDIF
+          IF ( gradient /= 0.0 )  THEN
+             IF ( k /= 1 )  THEN
+                ug(k) = ug(k-1) + dzu(k) * gradient
+             ELSE
+                ug(k) = ug_surface + 0.5 * dzu(k) * gradient
+             ENDIF
+          ELSE
+             ug(k) = ug(k-1)
+          ENDIF
+       ENDDO
+
+       u_init = ug
+
+!
+!--    In case of no given gradients for ug, choose a vanishing gradient
+       IF ( ug_vertical_gradient_level(1) == -1.0 )  THEN
+          ug_vertical_gradient_level(1) = 0.0
+       ENDIF  
+
+!
+!--
+!--    If required, compute initial profile of the geostrophic wind
+!--    (component vg)
+       i = 1
+       gradient = 0.0
+       vg_vertical_gradient_level_ind(1) = 0
+       vg(0) = vg_surface
+       DO  k = 1, nzt+1
+          IF ( vg_vertical_gradient_level(i) < zu(k)  .AND. &
+               vg_vertical_gradient_level(i) >= 0.0 )  THEN
+             gradient = vg_vertical_gradient(i) / 100.0
+             vg_vertical_gradient_level_ind(i) = k - 1
+             i = i + 1
+             IF ( i > 10 )  THEN
+                IF ( myid == 0 )  THEN
+                   PRINT*, '+++ check_parameters: upper bound 10 of array', &
+                           ' "vg_vertical_gradient_level_ind" exceeded'
+                ENDIF
+                CALL local_stop
+             ENDIF
+          ENDIF
+          IF ( gradient /= 0.0 )  THEN
+             IF ( k /= 1 )  THEN
+                vg(k) = vg(k-1) + dzu(k) * gradient
+             ELSE
+                vg(k) = vg_surface + 0.5 * dzu(k) * gradient
+             ENDIF
+          ELSE
+             vg(k) = vg(k-1)
+          ENDIF
+       ENDDO
+
+       v_init = vg
+ 
+!
+!--    In case of no given gradients for vg, choose a vanishing gradient
+       IF ( vg_vertical_gradient_level(1) == -1.0 )  THEN
+          vg_vertical_gradient_level(1) = 0.0
+       ENDIF
+
+!
+!--    If required, compute initial temperature profile using the given
+!--    temperature gradient
+       i = 1
+       gradient = 0.0
+       pt_vertical_gradient_level_ind(1) = 0
+       DO  k = 1, nzt+1
+          IF ( pt_vertical_gradient_level(i) < zu(k)  .AND. &
+               pt_vertical_gradient_level(i) >= 0.0 )  THEN
+             gradient = pt_vertical_gradient(i) / 100.0
+             pt_vertical_gradient_level_ind(i) = k - 1
+             i = i + 1
+             IF ( i > 10 )  THEN
+                IF ( myid == 0 )  THEN
+                   PRINT*, '+++ check_parameters: upper bound 10 of array', &
+                           ' "pt_vertical_gradient_level_ind" exceeded'
+                ENDIF
+                CALL local_stop
+             ENDIF
+          ENDIF
+          IF ( gradient /= 0.0 )  THEN
+             IF ( k /= 1 )  THEN
+                pt_init(k) = pt_init(k-1) + dzu(k) * gradient
+             ELSE
+                pt_init(k) = pt_init(k-1) + 0.5 * dzu(k) * gradient
+             ENDIF
+          ELSE
+             pt_init(k) = pt_init(k-1)
+          ENDIF
+       ENDDO
+
+!
+!--    In case of no given temperature gradients, choose gradient of neutral
+!--    stratification
+       IF ( pt_vertical_gradient_level(1) == -1.0 )  THEN
+          pt_vertical_gradient_level(1) = 0.0
+       ENDIF
+
+!
+!--    Store temperature gradient at the top boundary for possile Neumann
+!--    boundary condition
+       bc_pt_t_val = ( pt_init(nzt) - pt_init(nzt-1) ) / dzu(nzt)
+
+!
+!--    If required, compute initial humidity or scalar profile using the given
+!--    humidity/scalar gradient. In case of scalar transport, initially store
+!--    values of the scalar parameters on humidity parameters
+       IF ( passive_scalar )  THEN
+          bc_q_b                    = bc_s_b
+          bc_q_t                    = bc_s_t
+          q_surface                 = s_surface
+          q_surface_initial_change  = s_surface_initial_change
+          q_vertical_gradient       = s_vertical_gradient
+          q_vertical_gradient_level = s_vertical_gradient_level
+          surface_waterflux         = surface_scalarflux
+       ENDIF
+
+       IF ( moisture  .OR.  passive_scalar )  THEN
+
+          i = 1
+          gradient = 0.0
+          q_vertical_gradient_level_ind(1) = 0
           DO  k = 1, nzt+1
-             IF ( i < 11 )  THEN
-                IF ( ug_vertical_gradient_level(i) < zu(k)  .AND.                                  &
-                     ug_vertical_gradient_level(i) >= 0.0_wp )  THEN
-                   gradient = ug_vertical_gradient(i) / 100.0_wp
-                   ug_vertical_gradient_level_ind(i) = k - 1
-                   i = i + 1
-                ENDIF
-             ENDIF
-             IF ( gradient /= 0.0_wp )  THEN
+             IF ( q_vertical_gradient_level(i) < zu(k)  .AND. &
+                  q_vertical_gradient_level(i) >= 0.0 )  THEN
+                gradient = q_vertical_gradient(i) / 100.0
+                q_vertical_gradient_level_ind(i) = k - 1
+                i = i + 1
+                IF ( i > 10 )  THEN
+                   IF ( myid == 0 )  THEN
+                      PRINT*, '+++ check_parameters: upper bound 10 of arr', &
+                              'ay "q_vertical_gradient_level_ind" exceeded'
+                   ENDIF
+                   CALL local_stop
+                ENDIF
+             ENDIF
+             IF ( gradient /= 0.0 )  THEN
                 IF ( k /= 1 )  THEN
-                   ug(k) = ug(k-1) + dzu(k) * gradient
+                   q_init(k) = q_init(k-1) + dzu(k) * gradient
                 ELSE
-                   ug(k) = ug_surface + dzu(k) * gradient
+                   q_init(k) = q_init(k-1) + 0.5 * dzu(k) * gradient
                 ENDIF
              ELSE
-                ug(k) = ug(k-1)
+                q_init(k) = q_init(k-1)
              ENDIF
           ENDDO
 
-       ELSE
-
-          ug_vertical_gradient_level_ind(1) = nzt+1
-          ug(nzt+1) = ug_surface
-          DO  k = nzt, nzb, -1
-             IF ( i < 11 )  THEN
-                IF ( ug_vertical_gradient_level(i) > zu(k)  .AND.                                  &
-                     ug_vertical_gradient_level(i) <= 0.0_wp )  THEN
-                   gradient = ug_vertical_gradient(i) / 100.0_wp
-                   ug_vertical_gradient_level_ind(i) = k + 1
-                   i = i + 1
-                ENDIF
-             ENDIF
-             IF ( gradient /= 0.0_wp )  THEN
-                IF ( k /= nzt )  THEN
-                   ug(k) = ug(k+1) - dzu(k+1) * gradient
-                ELSE
-                   ug(k)   = ug_surface - 0.5_wp * dzu(k+1) * gradient
-                   ug(k+1) = ug_surface + 0.5_wp * dzu(k+1) * gradient
-                ENDIF
-             ELSE
-                ug(k) = ug(k+1)
-             ENDIF
-          ENDDO
-
-       ENDIF
-
-!
-!--    In case of no given gradients for ug, choose a zero gradient
-       IF ( ug_vertical_gradient_level(1) == -9999999.9_wp )  THEN
-          ug_vertical_gradient_level(1) = 0.0_wp
-       ENDIF
-
-!
-!--
-!--    If required, compute initial profile of the geostrophic wind (component vg)
-       i = 1
-       gradient = 0.0_wp
-
-       IF ( .NOT. ocean_mode )  THEN
-
-          vg_vertical_gradient_level_ind(1) = 0
-          vg(0) = vg_surface
-          DO  k = 1, nzt+1
-             IF ( i < 11 )  THEN
-                IF ( vg_vertical_gradient_level(i) < zu(k)  .AND.                                  &
-                     vg_vertical_gradient_level(i) >= 0.0_wp )  THEN
-                   gradient = vg_vertical_gradient(i) / 100.0_wp
-                   vg_vertical_gradient_level_ind(i) = k - 1
-                   i = i + 1
-                ENDIF
-             ENDIF
-             IF ( gradient /= 0.0_wp )  THEN
-                IF ( k /= 1 )  THEN
-                   vg(k) = vg(k-1) + dzu(k) * gradient
-                ELSE
-                   vg(k) = vg_surface + dzu(k) * gradient
-                ENDIF
-             ELSE
-                vg(k) = vg(k-1)
-             ENDIF
-          ENDDO
-
-       ELSE
-
-          vg_vertical_gradient_level_ind(1) = nzt+1
-          vg(nzt+1) = vg_surface
-          DO  k = nzt, nzb, -1
-             IF ( i < 11 )  THEN
-                IF ( vg_vertical_gradient_level(i) > zu(k)  .AND.                                  &
-                     vg_vertical_gradient_level(i) <= 0.0_wp )  THEN
-                   gradient = vg_vertical_gradient(i) / 100.0_wp
-                   vg_vertical_gradient_level_ind(i) = k + 1
-                   i = i + 1
-                ENDIF
-             ENDIF
-             IF ( gradient /= 0.0_wp )  THEN
-                IF ( k /= nzt )  THEN
-                   vg(k) = vg(k+1) - dzu(k+1) * gradient
-                ELSE
-                   vg(k)   = vg_surface - 0.5_wp * dzu(k+1) * gradient
-                   vg(k+1) = vg_surface + 0.5_wp * dzu(k+1) * gradient
-                ENDIF
-             ELSE
-                vg(k) = vg(k+1)
-             ENDIF
-          ENDDO
-
-       ENDIF
-
-!
-!--    In case of no given gradients for vg, choose a zero gradient
-       IF ( vg_vertical_gradient_level(1) == -9999999.9_wp )  THEN
-          vg_vertical_gradient_level(1) = 0.0_wp
-       ENDIF
-
-!
-!--    Let the initial wind profiles be the calculated ug/vg profiles or interpolate them from wind
-!--    profile data (if given)
-       IF ( u_profile(1) == 9999999.9_wp  .AND.  v_profile(1) == 9999999.9_wp )  THEN
-
-          u_init = ug
-          v_init = vg
-
-       ELSEIF ( u_profile(1) == 0.0_wp  .AND.  v_profile(1) == 0.0_wp )  THEN
-
-          IF ( uv_heights(1) /= 0.0_wp )  THEN
-             message_string = 'uv_heights(1) must be 0.0'
-             CALL message( 'check_parameters', 'PA0345', 1, 2, 0, 6, 0 )
-          ENDIF
-
-          IF ( omega /= 0.0_wp )  THEN
-             message_string = 'Coriolis force is switched on (omega /= 0.0) and' //                &
-                              ' initial profiles u_profile and v_profile are prescribed'
-             CALL message( 'check_parameters', 'PA0347', 0, 0, 0, 6, 0 )
-          ENDIF
-
-          use_prescribed_profile_data = .TRUE.
-
-          kk = 1
-          u_init(0) = 0.0_wp
-          v_init(0) = 0.0_wp
-
-          DO  k = 1, nz+1
-
-             IF ( kk < 200 )  THEN
-                DO  WHILE ( uv_heights(kk+1) <= zu(k) )
-                   kk = kk + 1
-                   IF ( kk == 200 )  EXIT
-                ENDDO
-             ENDIF
-
-             IF ( kk < 200  .AND.  uv_heights(kk+1) /= 9999999.9_wp )  THEN
-                u_init(k) = u_profile(kk) + ( zu(k) - uv_heights(kk) ) /                           &
-                                            ( uv_heights(kk+1) - uv_heights(kk) ) *                &
-                                            ( u_profile(kk+1) - u_profile(kk) )
-                v_init(k) = v_profile(kk) + ( zu(k) - uv_heights(kk) ) /                           &
-                                            ( uv_heights(kk+1) - uv_heights(kk) ) *                &
-                                            ( v_profile(kk+1) - v_profile(kk) )
-             ELSE
-                u_init(k) = u_profile(kk)
-                v_init(k) = v_profile(kk)
-             ENDIF
-
-          ENDDO
-
-       ELSE
-
-          message_string = 'u_profile(1) and v_profile(1) must be 0.0'
-          CALL message( 'check_parameters', 'PA0346', 1, 2, 0, 6, 0 )
-
-       ENDIF
-
-!
-!--    Compute initial temperature profile using the given temperature gradients
-       IF (  .NOT.  neutral )  THEN
-          CALL init_vertical_profiles( pt_vertical_gradient_level_ind, pt_vertical_gradient_level, &
-                                       pt_vertical_gradient, pt_init, pt_surface, bc_pt_t_val )
-       ENDIF
-!
-!--    Compute initial humidity profile using the given humidity gradients
-       IF ( humidity )  THEN
-          CALL init_vertical_profiles( q_vertical_gradient_level_ind, q_vertical_gradient_level,   &
-                                       q_vertical_gradient, q_init, q_surface, bc_q_t_val )
-       ENDIF
-!
-!--    Compute initial scalar profile using the given scalar gradients
-       IF ( passive_scalar )  THEN
-          CALL init_vertical_profiles( s_vertical_gradient_level_ind, s_vertical_gradient_level,   &
-                                       s_vertical_gradient, s_init, s_surface, bc_s_t_val )
-       ENDIF
-!
-!--    TODO
-!--    Compute initial chemistry profile using the given chemical species gradients
-!--    Russo: Is done in chem_init --> kanani: Revise
-
-    ENDIF
-
-!
-!-- Check if the control parameter use_subsidence_tendencies is used correctly
-    IF ( use_subsidence_tendencies  .AND.  .NOT.  large_scale_subsidence )  THEN
-       message_string = 'The usage of use_subsidence_tendencies ' //                               &
-                        'requires large_scale_subsidence = .T..'
-       CALL message( 'check_parameters', 'PA0396', 1, 2, 0, 6, 0 )
-    ELSEIF ( use_subsidence_tendencies  .AND.  .NOT. large_scale_forcing )  THEN
-       message_string = 'The usage of use_subsidence_tendencies ' //           &
-                        'requires large_scale_forcing = .T..'
-       CALL message( 'check_parameters', 'PA0397', 1, 2, 0, 6, 0 )
-    ENDIF
-
-!
-!-- Initialize large scale subsidence if required
-    If ( large_scale_subsidence )  THEN
-       IF ( subs_vertical_gradient_level(1) /= -9999999.9_wp  .AND. .NOT. large_scale_forcing )    &
-       THEN
-          CALL init_w_subsidence
-       ENDIF
-!
-!--    In case large_scale_forcing is used, profiles for subsidence velocity are read in from file
-!--    LSF_DATA
-
-       IF ( subs_vertical_gradient_level(1) == -9999999.9_wp  .AND. .NOT. large_scale_forcing )    &
-       THEN
-          message_string = 'There is no default large scale vertical velocity profile set. ' //    &
-                           'Specify the subsidence velocity profile via subs_vertical_gradient' // &
-                           ' and subs_vertical_gradient_level.'
-          CALL message( 'check_parameters', 'PA0380', 1, 2, 0, 6, 0 )
-       ENDIF
-    ELSE
-        IF ( subs_vertical_gradient_level(1) /= -9999999.9_wp )  THEN
-           message_string = 'Enable usage of large scale subsidence by ' //                        &
-                            'setting large_scale_subsidence = .T..'
-          CALL message( 'check_parameters', 'PA0381', 1, 2, 0, 6, 0 )
-        ENDIF
-    ENDIF
-
-!
-!-- Overwrite parameters from namelist if necessary and compute Coriolis parameter.
-!-- @todo - move initialization of f and fs to coriolis_mod.
-    IF ( input_pids_static )  THEN
-       latitude       = init_model%latitude
-       longitude      = init_model%longitude
-       rotation_angle = init_model%rotation_angle
-    ENDIF
-
-    f  = 2.0_wp * omega * SIN( latitude / 180.0_wp * pi )
-    fs = 2.0_wp * omega * COS( latitude / 180.0_wp * pi )
-
-!
-!-- Check and set buoyancy related parameters and switches
-    IF ( reference_state == 'horizontal_average' )  THEN
-       CONTINUE
-    ELSEIF ( reference_state == 'initial_profile' )  THEN
-       use_initial_profile_as_reference = .TRUE.
-    ELSEIF ( reference_state == 'single_value' )  THEN
-       use_single_reference_value = .TRUE.
-       IF ( pt_reference == 9999999.9_wp )  pt_reference = pt_surface
-       vpt_reference = pt_reference * ( 1.0_wp + 0.61_wp * q_surface )
-    ELSE
-       message_string = 'illegal value for reference_state: "' // TRIM( reference_state ) // '"'
-       CALL message( 'check_parameters', 'PA0056', 1, 2, 0, 6, 0 )
-    ENDIF
+!
+!--       In case of no given humidity gradients, choose zero gradient
+!--       conditions
+          IF ( q_vertical_gradient_level(1) == -1.0 )  THEN
+             q_vertical_gradient_level(1) = 0.0
+          ENDIF
+
+!
+!--       Store humidity gradient at the top boundary for possile Neumann
+!--       boundary condition
+          bc_q_t_val = ( q_init(nzt) - q_init(nzt-1) ) / dzu(nzt)
+
+       ENDIF
+
+    ENDIF
+
+!
+!-- Compute Coriolis parameter
+    f  = 2.0 * omega * SIN( phi / 180.0 * pi )
+    fs = 2.0 * omega * COS( phi / 180.0 * pi )
 
 !
 !-- In case of a given slope, compute the relevant quantities
-    IF ( alpha_surface /= 0.0_wp )  THEN
-       IF ( ABS( alpha_surface ) > 90.0_wp )  THEN
-          WRITE( message_string, * ) 'ABS( alpha_surface = ', alpha_surface, ' ) must be < 90.0'
-          CALL message( 'check_parameters', 'PA0043', 1, 2, 0, 6, 0 )
+    IF ( alpha_surface /= 0.0 )  THEN
+       IF ( ABS( alpha_surface ) > 90.0 )  THEN
+          IF ( myid == 0 )  PRINT*, '+++ check_parameters: ABS( alpha_surface',&
+                                    '=', alpha_surface, ' ) must be < 90.0'
+          CALL local_stop
        ENDIF
        sloping_surface = .TRUE.
-       cos_alpha_surface = COS( alpha_surface / 180.0_wp * pi )
-       sin_alpha_surface = SIN( alpha_surface / 180.0_wp * pi )
+       cos_alpha_surface = COS( alpha_surface / 180.0 * pi )
+       sin_alpha_surface = SIN( alpha_surface / 180.0 * pi )
     ENDIF
 
 !
 !-- Check time step and cfl_factor
-    IF ( dt /= -1.0_wp )  THEN
-       IF ( dt <= 0.0_wp )  THEN
-          WRITE( message_string, * ) 'dt = ', dt , ' <= 0.0'
-          CALL message( 'check_parameters', 'PA0044', 1, 2, 0, 6, 0 )
+    IF ( dt /= -1.0 )  THEN
+       IF ( dt <= 0.0  .AND.  dt /= -1.0 )  THEN
+          IF ( myid == 0 )  PRINT*, '+++ check_parameters:  dt=', dt, ' <= 0.0'
+          CALL local_stop
        ENDIF
        dt_3d = dt
@@ -1195,17 +696,25 @@
     ENDIF
 
-    IF ( cfl_factor <= 0.0_wp  .OR.  cfl_factor > 1.0_wp )  THEN
-       IF ( cfl_factor == -1.0_wp )  THEN
-          IF ( timestep_scheme == 'runge-kutta-2' )  THEN
-             cfl_factor = 0.8_wp
-          ELSEIF ( timestep_scheme == 'runge-kutta-3' )  THEN
-             cfl_factor = 0.9_wp
+    IF ( cfl_factor <= 0.0  .OR.  cfl_factor > 1.0 )  THEN
+       IF ( cfl_factor == -1.0 )  THEN
+          IF ( momentum_advec == 'ups-scheme'  .OR.  &
+               scalar_advec == 'ups-scheme' )  THEN
+             cfl_factor = 0.8
           ELSE
-             cfl_factor = 0.9_wp
+             IF ( timestep_scheme == 'runge-kutta-2' )  THEN
+                cfl_factor = 0.8
+             ELSEIF ( timestep_scheme == 'runge-kutta-3' )  THEN
+                cfl_factor = 0.9
+             ELSE
+                cfl_factor = 0.1
+             ENDIF
           ENDIF
        ELSE
-          WRITE( message_string, * ) 'cfl_factor = ', cfl_factor,                                  &
-                 ' out of range &0.0 < cfl_factor <= 1.0 is required'
-          CALL message( 'check_parameters', 'PA0045', 1, 2, 0, 6, 0 )
+          IF ( myid == 0 )  THEN
+             PRINT*, '+++ check_parameters: cfl_factor=', cfl_factor, &
+                         ' out of range'
+             PRINT*, '+++                   0.0 < cfl_factor <= 1.0 is required'
+          ENDIF
+          CALL local_stop
        ENDIF
     ENDIF
